// Main.cpp: Implementierung der Klasse CMain.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Main.h"
#include "TraceData.h"
#include "Messages.h"
#include "resource.h"
#include "RNProtokoll.h"

extern CString g_csPath;
extern DWORD  g_dwTraceThreadId;
extern HANDLE g_hTraceThreadHandle;
extern unsigned __stdcall TraceThread(LPVOID pParam);
extern HANDLE g_hTraceMsg;
extern int     g_iTraceLevel;

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
// Klasse wo der eingendliche ablauf drin ist
// Htte man auch im Dialog machen knnen aber ich will das 
// Spter in einen eineg Thread packen.
// Dialog haben einanders Thread Timing und was interressiert die oberflsche
//////////////////////////////////////////////////////////////////////

CMain::CMain()
{
	m_bShutdown = false;
}

CMain::~CMain()
{

}

bool CMain::Init()
{
	// Jetzt geht es wirklich los
	// Wird spter automatisch auf gerufen zur Zeit ber Button (Connect Button) 
	TraceIt("Init() -->");

	m_csIniFile = g_csPath;
	m_csIniFile +="SerialServer.ini";
	TCHAR Comport[15];
	TCHAR Baud[15];

	GetPrivateProfileString(TEXT("SerialServer"), TEXT("Comport"), TEXT("NIX"),Comport,sizeof(Comport),m_csIniFile);
	if (strcmp(Comport,"NIX")==0)
	{
		strcpy(Comport,"COM1");
		WritePrivateProfileString(TEXT("SerialServer"), TEXT("Comport"), TEXT("COM1"),m_csIniFile);
	}

	GetPrivateProfileString(TEXT("SerialServer"), TEXT("Baud"), TEXT("NIX"),Baud,sizeof(Baud),m_csIniFile);
	if (strcmp(Baud,"NIX")==0)
	{
		strcpy(Baud,"9600");
		WritePrivateProfileString(TEXT("SerialServer"), TEXT("Baud"), TEXT("9600"),m_csIniFile);
	}

	m_clV24.m_csCOM = Comport;
	m_clV24.m_iBaud = atol(Baud);
			
	if(m_clV24.m_csCOM != "NONE")
	{
		if(m_clV24.Init())
		{
			TraceIt("V24 ReadStartet");
		}
	}

	TraceIt("Init() <--");
	return true;
}

bool CMain::InitTrace()
{
	// Tracegeraffel auf bauen
	g_hTraceMsg = CreateEvent(NULL,TRUE,FALSE,NULL);

	g_hTraceThreadHandle=(HANDLE)_beginthreadex(NULL,0,TraceThread,NULL,CREATE_SUSPENDED,reinterpret_cast<unsigned int*>(&g_dwTraceThreadId));
	SetThreadPriority(g_hTraceThreadHandle, THREAD_PRIORITY_IDLE);
	ResumeThread(g_hTraceThreadHandle);

	if(WaitForSingleObject(g_hTraceMsg,30000) == WAIT_OBJECT_0)
	{
		CString csTrace;
		csTrace = "**********************************************************";
		TraceIt(csTrace);
		csTrace.Format("First Trace Entry from Version %s",GetVersion());
		TraceIt(csTrace);
		csTrace = "**********************************************************";
		TraceIt(csTrace);

		return true;
	}
	else
	{
		ATLTRACE("Nix Trace Thread\n");
		return false;
	}
}

CString CMain::GetVersion()
{
	//Versionsnummer aus der exe holen damit man die im Source nicht Pflegen mu

    DWORD garbage;

    DWORD size = ::GetFileVersionInfoSize("SerialServer.exe", &garbage);
	CString csVersion;

    if(size > 0)
    {
        char *buffer = new char[size];
        char *info;
        UINT sizeInfo;

        if(::GetFileVersionInfo("SerialServer.exe", 0, size, (void *)buffer))
        {
            if(::VerQueryValue((void *)buffer, _T("\\StringFileInfo\\040904b0\\ProductVersion"),
                        (void **)&info, &sizeInfo))
            {
                csVersion = "Version : ";
				csVersion += info;
                csVersion.Left(sizeInfo+10);
				m_csVersion = info;
            }
        }
        delete buffer;
    }
	return csVersion;
}

void CMain::TraceIt(CString TraceString)
{
	if(!m_bShutdown)
	{
		if(g_iTraceLevel >= 1)
		{
			TraceData* Buffer;
			Buffer = new TraceData;
			Buffer->m_ListBox = 0;
			Buffer->m_TraceString  = "CMain ";
			Buffer->m_TraceString += TraceString;
			PostThreadMessage(g_dwTraceThreadId,WM_TRACEIT,NULL,(long) Buffer);
		}
	}
}

void CMain::Deinit()
{
	TraceIt("App ends");
	Sleep(100);

	m_bShutdown = true;

	m_clV24.Deinit();
	//Do Things

	PostThreadMessage(g_dwTraceThreadId,WM_SHUTDOWN,NULL,NULL);
	WaitForSingleObject(g_hTraceThreadHandle,30000);
	CloseHandle(g_hTraceThreadHandle);
	CloseHandle(g_hTraceMsg);

}

void CMain::V24DataIn(WPARAM wParam,LPARAM lParam)
{
	// Hier kammen daten von der Com
	BYTE* SendBuffer = (BYTE*)lParam;
	// Todo: richtigen Cast machen
	
	if(SendBuffer)
	{
		int len = wParam;
		if(len > 0)
		{
			CString csTrace;
			csTrace.Format("Neue Daten %s",BinToTrace(SendBuffer,len));
			TraceIt(csTrace);

			
			CRNProtokoll* pBuffer = new CRNProtokoll;
			pBuffer->SetByteDataEncode(SendBuffer,len);
			
			BYTE Telegramlen;
			bool result = pBuffer->GetEncode(SendBuffer,Telegramlen);

			csTrace.Format("Neue Daten %s",BinToTrace(SendBuffer,Telegramlen));
			TraceIt(csTrace);
			
			CString csDaten = "";
			if(result)
			{
				csDaten = BinToTrace(SendBuffer,Telegramlen);
			}
			else
			{
				csDaten = "Prfsumme passt nicht";
			}
			// Daten in der Listbox ausgeben
			int count = SendMessage(GetDlgItem(m_hMainDlg,IDC_DATEN_LIST), LB_GETCOUNT , 0, 0);
			if(count >= 10)
			{
				SendMessage(GetDlgItem(m_hMainDlg,IDC_DATEN_LIST), LB_DELETESTRING, 0, 0);
			}
			SendMessage(GetDlgItem(m_hMainDlg,IDC_DATEN_LIST),LB_INSERTSTRING,0,(long)csDaten.operator LPCTSTR());

			delete pBuffer;

		}
		delete SendBuffer;
	}
}

CString CMain::BinToTrace(BYTE *Daten, int len)
{
	// Helper funktion um besser/schner zu tracen
	CString csResult = "";
	for(int x=0;x<len;x++)
	{
		if((Daten[x]<32) || (Daten[x] >122))
		{
			CString csDummy;
			csDummy.Format("<%02X>",Daten[x]);
			csResult += csDummy;
		}
		else
		{
			csResult += Daten[x];
		}
	}
	return csResult;
}

void CMain::SendBuffer(BYTE *buffer,int len)
{
	// Daten zu sammenbauen und schicken

	CRNProtokoll* pBuffer = new CRNProtokoll;

	pBuffer->SetByteDataDecode(buffer,len);

	// Wie lange ist das was wir senden mssen ?
	len = pBuffer->GetLevel0(NULL);

	BYTE* SendBuffer = new BYTE[len];
	
	// Holen der daten ?
	pBuffer->GetLevel0(SendBuffer);

	CString csTrace;
	csTrace.Format("Schreibe Daten %s",BinToTrace(SendBuffer,len));
	TraceIt(csTrace);

	m_clV24.WriteOut(SendBuffer,len);

	delete SendBuffer;
	delete pBuffer;
}
