// maindlg.cpp : implementation of the CMainDlg class
// Klasse zu Steuern des Dialogs was man halt so Braucht
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "resource.h"

#include "aboutdlg.h"
#include "maindlg.h"

extern CString g_csPath;

BOOL CMainDlg::PreTranslateMessage(MSG* pMsg)
{
	return CWindow::IsDialogMessage(pMsg);
}

BOOL CMainDlg::OnIdle()
{
	return FALSE;
}

LRESULT CMainDlg::OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	// center the dialog on the screen
	CenterWindow();

	// set icons
	HICON hIcon = (HICON)::LoadImage(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), 
		IMAGE_ICON, ::GetSystemMetrics(SM_CXICON), ::GetSystemMetrics(SM_CYICON), LR_DEFAULTCOLOR);
	SetIcon(hIcon, TRUE);
	HICON hIconSmall = (HICON)::LoadImage(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), 
		IMAGE_ICON, ::GetSystemMetrics(SM_CXSMICON), ::GetSystemMetrics(SM_CYSMICON), LR_DEFAULTCOLOR);
	SetIcon(hIconSmall, FALSE);

	// register object for message filtering and idle updates
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	ATLASSERT(pLoop != NULL);
	pLoop->AddMessageFilter(this);
	pLoop->AddIdleHandler(this);

	UIAddChildWindowContainer(m_hWnd);

	CString csCommandLine;
    csCommandLine = GetCommandLine();
    csCommandLine.Replace('"',' ');
    csCommandLine.TrimRight();
    csCommandLine.TrimLeft();

    int wo = csCommandLine.ReverseFind('\\');
    g_csPath = csCommandLine.Mid(0,wo+1);
	
	m_clMain.m_hMainDlg = m_hWnd;
	m_clMain.InitTrace();

	return TRUE;
}

LRESULT CMainDlg::OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	// unregister message filtering and idle updates
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	ATLASSERT(pLoop != NULL);
	pLoop->RemoveMessageFilter(this);
	pLoop->RemoveIdleHandler(this);
	// if UI is the last thread, no need to wait
	if(_Module.GetLockCount() == 1)
	{
		_Module.m_dwTimeOut = 0L;
		_Module.m_dwPause = 0L;
	}
	_Module.Unlock();
	return 0;
}

LRESULT CMainDlg::OnAppAbout(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	CAboutDlg dlg;
	dlg.DoModal();
	return 0;
}

LRESULT CMainDlg::OnOK(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	// TODO: Add validation code 
	CloseDialog(wID);
	return 0;
}

void CMainDlg::CloseDialog(int nVal)
{
	m_clMain.Deinit();

	DestroyWindow();
	::PostQuitMessage(nVal);
}

LRESULT CMainDlg::OnClickedConnect_button(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(!m_clMain.Init())
	{
		MessageBox("Init Ging Schief bitte Einstellungen Kontrolieren","SerialServer",MB_OK);
		CloseDialog(99);
	}
	::EnableWindow(GetDlgItem(IDC_CONNECT_BUTTON),FALSE);
	return 0;
}

LRESULT CMainDlg::OnV24Data(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	// Daten an den Verarbeiten weiter geben
	m_clMain.V24DataIn(wParam,lParam);
	bHandled = TRUE;
	return 0;
}

LRESULT CMainDlg::OnClickedSend_button(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	char buffer[200];
	BYTE* data = new BYTE[200];
	int len = 0;

	GetDlgItemText(IDC_SEND_EDIT,(char*)&buffer,199);

	for(WORD x=0;x<strlen(buffer);x++)
	{
		if(buffer[x] != '<')
		{
			data[len] = buffer[x];
			len++;
		}
		else
		{
			if(buffer[x+1] == '<')
			{
				data[len] = '<';
				len++;
				x++;
			}
			else
			{
				char Value[3] = {0,0,0};
				Value[0] = buffer[x+1];
				Value[1] = buffer[x+2];

				data[len] = (BYTE)strtoul(Value,0,16);
				len++;
				x++;
				x++;
				x++;
			}
		}
	}
    /*CString csDaten = buffer;
    CString csChar = "";

    int pos = 0;
    while(pos > -1)
    {
        pos=csDaten.Find("<");
        if(pos >-1)
        {
            if(csDaten.Mid(pos+1,1) != "<")
            {
                csChar = csDaten.Mid(pos+1,2);
                BYTE mChar = (BYTE)strtoul(csChar,0,16);
                if(mChar == 0)
                {
                    mChar = 255;
                }
                CString csBegin = csDaten.Mid(0,pos);
                CString csEnde= csDaten.Mid(pos+4,csDaten.GetLength()-pos-4);
                csDaten = csBegin;
                csDaten += mChar;
                csDaten += csEnde;
            }
        }
    }*/

	m_clMain.SendBuffer(data,len);

	delete data;

	return 0;
}